<template>
  <div class="sg-page-content">
    <div class="sg-breadcrumb" v-if="is_shimmer">
      <div class="container">
        <ol class="breadcrumb justify-content-center">
          <li class="breadcrumb-item">{{ lang.view_cart }}</li>
          <li class="breadcrumb-item"><a href="javascript:void(0)">{{ lang.check_out }}</a></li>
          <li class="breadcrumb-item"><a href="javascript:void(0)">{{ lang.confirm_order }}</a></li>
        </ol>
      </div>
    </div><!-- /.sg-breadcrumb -->
    <section class="sg-global-content">
      <div class="container" v-if="is_shimmer">
        <div class="row" v-if="cartList && cartList.length > 0">
          <div class="col-lg-8 justify-content-end">
            <div class="accordion" id="accordionExample">
              <div v-if="seller_carts" class="accordion-item"
                   v-for="(seller_cart,seller_id,seller_index) in seller_carts"
                   :class="{'cart_accordion' : collapseAttribute[seller_index].status }">
                <div class="accordion-header" :id="'cart'+seller_index">
                  <button class="accordion-button title"
                          @click="collapseAttribute[seller_index].status = !collapseAttribute[seller_index].status"
                          :class="{ 'collapsed' :  !collapseAttribute[seller_index].status }"
                          type="button"
                          data-bs-toggle="collapse" data-bs-target="#category"
                          aria-expanded="true" aria-controls="collapse1">
                    {{ collapseAttribute[seller_index].name }}
                  </button>
                </div>
                <div :id="'cart'+seller_index" class="accordion-collapse collapse"
                     :class="{ 'show' : collapseAttribute[seller_index].status }"
                     :aria-labelledby="'cart'+seller_index"
                     data-bs-parent="#accordionExample">
                  <div class="accordion-body">
                    <div class="sg-table table-responsive">
                      <table class="table">
                        <thead>
                        <tr>
                          <th scope="col">{{ lang.product }}</th>
                          <th scope="col">{{ lang.unit_price }}</th>
                          <th scope="col">{{ lang.quantity }}</th>
                          <th scope="col">{{ lang.total_price }}</th>
                          <th scope="col">{{ lang.action }}</th>
                        </tr>
                        </thead>
                        <tbody>
                        <tr v-for="(cart,index) in carts" :key="index"
                            v-if="seller_id == cart.seller_id">
                          <th scope="row">
                            <div class="product">
                              <router-link
                                  :to="{name: 'product.details',params: {slug:cart.product_slug}}">
                                                            <span class="product-thumb">
                                                                <img :src="cart.image_72x72" :alt="cart.product_name"
                                                                     class="img-fluid">
                                                            </span>
                                <div class="text">
                                  <p>{{ cart.product_name }}</p>
                                  <span v-if="cart.sku">{{ lang.SKU }}: {{
                                      cart.sku
                                    }}</span>
                                </div>
                              </router-link>
                            </div>
                          </th>
                          <td>
                                                        <span v-if="cart.discount > 0"><del>{{
                                                            priceFormat((cart.price))
                                                          }}</del></span>
                            <span>{{ priceFormat(cart.price - cart.discount) }}</span>
                          </td>
                          <td v-if="cart.is_digital_product == 1">
                            1
                          </td>
                          <td width="10%" v-else>
                            <div class="product-quantity">
                              <div class="quantity" data-trigger="spinner">
                                <a class="btn pull-left" @click="cartMinus(index)"
                                   href="javascript:void(0);"
                                   data-spin="down"><span
                                    class="mdi mdi-name mdi-minus"></span></a>
                                <input type="text" name="quantity"
                                       v-model="payment_form.quantity[index].quantity"
                                       title="quantity" readonly
                                       class="input-text">
                                <a class="btn pull-right" @click="cartPlus(index)"
                                   href="javascript:void(0);" data-spin="up"><span
                                    class="mdi mdi-name mdi-plus"></span></a>
                              </div>
                            </div>
                          </td>
                          <td><span v-if="cart.discount > 0"><del>{{
                              priceFormat((cart.price * payment_form.quantity[index].quantity))
                            }}</del></span>
                            <span>{{
                                priceFormat((cart.price - cart.discount) * payment_form.quantity[index].quantity)
                              }}</span></td>
                          <td>
                            <div class="delete">
                              <a @click="deleteCart(cart.id)"
                                 href="javascript:void(0)">{{ lang.delete }}</a>
                            </div>
                          </td>
                        </tr>
                        </tbody>
                      </table>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
          <div class="col-lg-4 pl-lg-5">
            <div class="order-summary">
              <h6>{{ lang.price_details }}</h6>
              <coupon  :coupon_list="coupon_list" :cartList="cartList"></coupon>
              <div class="sg-card">
                <payment_details
                    :sub_total="payment_form.sub_total"
                    :tax="payment_form.tax"
                    :discount_offer="payment_form.discount_offer"
                    :shipping_tax="payment_form.shipping_tax"
                    :coupon_discount="payment_form.coupon_discount"
                    :total="payment_form.total"
                ></payment_details>
                <a  href="javascript:void(0)" @click="handleCheckout"
                             class="btn btn-primary" style="color:white !important;background-color: #66101F;">{{ lang.proceed_to_checkout }}
                </a>
              </div>
            </div>
          </div>
        </div><!-- /.row -->
        <div  class="justify-content-center text-center">
          <!-- <h4 class="breadcrumb-item text-danger"> {{ lang.no_product_found }} </h4> -->
        </div>
      </div>
      <div class="container" v-else-if="shimmer">
        <div class="row">
          <div class="col-lg-8 justify-content-end">
            <shimmer class="mb-3" :height="100" v-for="(cart,i) in 4" :key="i"></shimmer>
          </div>
          <div class="col-lg-4 pl-lg-5">
            <shimmer :height="400"></shimmer>
          </div>
        </div>
      </div>
    </section><!-- /.shopping-cart -->
    <div v-if="similers.length>0" class="container">

  <h1>Similar Products</h1>
    <ul class="products grid-33" >
			<li  v-for="(product, index) in similers" :key="index">
				<div class="sg-product" :class="{ 'style-1': type == 'flash' }">
					<a :href="getUrl('product/' + product.slug)" @click.prevent="routerNavigator('product.details', product.slug)">
						<div class="product-thumb">
							<div class="span_container" style="min-height: 40px !important;">
								<span>
									<span class="base new">New</span>
									<span class="base reword-badge" v-if="addons.includes('reward') && product.reward > 0">
										Reward: {{ product.reward }}
									</span>
								</span>
								<span v-if="authUser">
									<span class="favorite_span" v-if="$store.getters.isThisWishlisted(product.id)">
										<a href="javaScript:void(0)" @click="removeWishlist(product.id)">
											<span class="mdi mdi-name mdi-heart"></span>
										</a>
									</span>
									<span class="favorite_span" v-else>
										<a href="javaScript:void(0)" :class="{ 'disable_btn' :  is_disabled == true }" @click="addToWishlist(product.id)">
											<span class="mdi mdi-name mdi-heart-outline"></span>
										</a>
									</span>
								</span>
							</div>
							<!-- <span class="base" v-if="product.special_discount_check > 0">{{ product.special_discount_type == "flat" ? priceFormat(product.special_discount_check) + " " + lang.off : product.special_discount_check + "% " + lang.off }} </span> -->
							<!-- <span v-if="product.current_stock == 0 && !product.is_classified" class="base stock_badge">{{ lang.out_of_stock }}</span> -->
							<!-- <span class="base reword-badge" v-if="addons.includes('reward') && product.reward > 0">{{ lang.reward_point }}: {{ product.reward }}</span> -->
							<img :src="product.image" :alt="product.product_name" class="img-fluid" loading="lazy" style="object-fit: cover;width: 100%;height: 100%"/>
						</div>
					</a>
					<div class="product-info">
						<h1 class="product-name text-ellipse-one" :title="product.product_name">
							<a :href="getUrl('product/' + product.slug)" @click.prevent="routerNavigator('product.details', product.slug)">
								{{ product.title }}
							</a>
						</h1>
						<span class="price">
							<div v-if="product.special_discount_check > 0">
								<span>
								{{ priceFormat(product.discount_price) }}
								</span>
								<div class="discount_style">
									<del>{{ priceFormat(product.price) }} </del>
									<span class="base discount">
										{{ product.special_discount_type == 'flat' ? priceFormat(product.special_discount_check) + ' '+lang.off : product.special_discount_check + '% '+lang.off }} 
									</span>
								</div>
							</div>
							<span v-else>{{ priceFormat(product.price) }}</span>
						</span>



						<!-- <span class="base" >{{ product.special_discount_type == "flat" ? priceFormat(product.special_discount_check) + " " + lang.off : product.special_discount_check + "% " + lang.off }} </span> -->
						<!-- <span class="price">
							<del >{{ priceFormat(product.price) }}</del>
							<span class="discount_style" >
								{{ priceFormat(product.discount_percentage) }}
							</span>
							<span >{{ priceFormat(product.price) }}</span>
						</span> -->
						<!-- <h1 class="product-name text-ellipse-one" :title="product.product_name">
							<a :href="getUrl('product/' + product.slug)" @click.prevent="routerNavigator('product.details', product.slug)">
								{{ product.product_name }}
							</a>
						</h1> -->
						<div class="icons">
							<div class="inner_icon_container">
								<div class="sg-rating" v-if="!addons.includes('ishopet')">
									<!-- <star-rating v-model:rating="product.rating" :read-only="true" :star-size="12" :round-start-rating="false"></star-rating> -->
									<div style="display:flex !important;flex-direction: row-reverse !important;gap:6px !important" class="rev" v-if="product.reviews_count > 0">
										<div v-if="product.reviews_count > 0"><span>({{product.reviews_count}} reviews)</span></div>
										<div class="rat_father">
											<div class="starrr"></div>
											<span class="rat_num" style="font-size:14px !important">{{ product.rating }}</span>
										</div>
									</div>
								</div>
								<ul class="global-list">
									<li>
										<a href="javaScript:void(0)" @click="productFetch(product.slug)">
											<span class="mdi mdi-name mdi-magnify"> <Search/></span>
										</a>
									</li>
									<li>
										<a href="javascript:void(0);" @click="cartBtn(product, index)">
											
											<span class="mdi mdi-name mdi-shopping-outline"><Bag/></span>
										</a>
									</li>
								</ul>
							</div>
						</div>
						<div class="sg-rating" v-if="!addons.includes('ishopet')">
							<star-rating v-model:rating="product.rating" :read-only="true" :star-size="12" :round-start-rating="false"></star-rating>
								<span class="reviews" v-if="product.reviews_count > 0">({{ product.reviews_count }} {{ lang.reviews }})</span>
						</div>
						<ul class="global-list">
							<li>
								<a href="javaScript:void(0)" @click="productFetch(product.slug)">
									<span class="mdi mdi-name mdi-magnify"> <Search/></span>
								</a>
							</li>
							<li>
								<a href="javascript:void(0);" @click="cartBtn(product, index)">
									
									<span class="mdi mdi-name mdi-shopping-outline"><Bag/></span>
								</a>
							</li>
						</ul>
						<div class="buttons d-flex align-items-center justify-content-center mt-1'">
							<a href="javascript:void(0);" @click="cartBtn(product, index)" class="btn btn-primary"><svg xmlns="http://www.w3.org/2000/svg" id="Outline" viewBox="0 0 24 24" width="42" height="42"><path d="M21,6H18A6,6,0,0,0,6,6H3A3,3,0,0,0,0,9V19a5.006,5.006,0,0,0,5,5H19a5.006,5.006,0,0,0,5-5V9A3,3,0,0,0,21,6ZM12,2a4,4,0,0,1,4,4H8A4,4,0,0,1,12,2ZM22,19a3,3,0,0,1-3,3H5a3,3,0,0,1-3-3V9A1,1,0,0,1,3,8H6v2a1,1,0,0,0,2,0V8h8v2a1,1,0,0,0,2,0V8h3a1,1,0,0,1,1,1Z"></path></svg>
							</a>
							<div class="zzz">
								<svg width="29" height="29" viewBox="0 0 29 29" fill="none" xmlns="http://www.w3.org/2000/svg">
									<path d="M9.77757 5.8C7.36049 5.8 5.39404 7.76764 5.39404 10.1861C5.39404 10.5221 5.66626 10.7945 6.00197 10.7945C6.33773 10.7945 6.60989 10.5221 6.60989 10.1861C6.60989 8.43844 8.03089 7.01659 9.77757 7.01659C10.1133 7.01659 10.3855 6.74426 10.3855 6.40827C10.3855 6.07233 10.1133 5.8 9.77757 5.8Z" fill="#660F1F"/>
									<path d="M20.4845 17.0778C21.5834 15.3539 22.2202 13.3086 22.2202 11.1167C22.2202 4.98641 17.2368 0 11.1101 0C8.91948 0 6.87538 0.637207 5.15254 1.73677C3.77986 2.61244 2.6117 3.78127 1.73655 5.15475C0.637604 6.87866 0 8.92475 0 11.1167C0 17.2462 4.98426 22.2333 11.1101 22.2333C13.3007 22.2333 15.3456 21.5953 17.0685 20.4957C18.4412 19.6201 19.6093 18.4512 20.4845 17.0778ZM14.7129 18.1387C13.6324 18.6962 12.4071 19.0111 11.1101 19.0111C6.76029 19.0111 3.2203 15.4691 3.2203 11.1167C3.2203 9.81893 3.53511 8.59289 4.09223 7.51185C4.84657 6.04735 6.04537 4.84866 7.50896 4.09466C8.58938 3.53721 9.8139 3.22223 11.1101 3.22223C15.4607 3.22223 18.9999 6.76346 18.9999 11.1167C18.9999 12.4136 18.6851 13.6389 18.1279 14.7199C17.3745 16.1844 16.1765 17.3839 14.7129 18.1387Z" fill="#660F1F"/>
									<path d="M28.2929 24.874L21.8788 18.4722C20.9658 19.8062 19.7961 20.9758 18.4629 21.8902L24.8769 28.2919C25.3487 28.764 25.967 29 26.5845 29C27.2028 29 27.8212 28.764 28.2929 28.2919C29.2357 27.3478 29.2357 25.818 28.2929 24.874Z" fill="#660F1F"/>
								</svg>
							</div>
						
						</div>
						<div class="icons">
							<ul class="global-list">
								<li v-if="product.minimum_order_quantity <= product.current_stock && !product.is_catalog && !product.is_classified" >
									<a href="javaScript:void(0)" @click="cartBtn(product, index)"><span class="mdi mdi-name mdi-shopping-outline"></span></a>
								</li>
								<div v-if="authUser">
									<li v-if="$store.getters.isThisWishlisted(product.id)">
										<a href="javaScript:void(0)" @click="removeWishlist(product.id)"><span class="mdi mdi-name mdi-heart"></span></a>
									</li>
									<li v-else>
										<a href="javaScript:void(0)" :class="{ disable_btn: is_disabled == true }" @click="addToWishlist(product.id)"><span class="mdi mdi-name mdi-heart-outline"></span></a>
									</li>
								</div>
								<!-- <li v-if="compareCheck(product)">
									<a class="active_compare" :class="{ disable_btn: is_disabled == true }" @click="removeCompare(product.id)" href="javaScript:void(0)"><span class="mdi mdi-name mdi-scale-balance"></span></a>
								</li> -->
								<li v-else>
									<a @click="addToCompare(product)" :class="{ disable_btn: is_disabled == true }" href="javaScript:void(0)"><span class="mdi mdi-name mdi-scale-balance"></span></a>
								</li>
								<li>
									<a href="javaScript:void(0)" @click="productFetch(product.slug)"><span class="mdi mdi-name mdi-magnify"></span></a>
								</li>
							</ul>
						</div>
					</div>
				</div><!-- /.sg-product -->
			</li>
		</ul>
  </div>
  </div>
</template>

<script>
import shimmer from "../partials/shimmer";
import coupon from "../partials/coupon";
import payment_details from "../partials/payment_details";

export default {
  name: "cart",
  components: {
    shimmer, coupon, payment_details
  },

  data() {
    return {
      carts: [],
      seller_carts: [],
      coupon_area: true,
      coupon: [],
      cart_length: 0,
      collapseAttribute: [],
      disable: false,
      is_shimmer: false,
      coupon_list: [],
      similers:[],
    }
  },
  mounted() {
    this.getCheckout();
    this.loadSimilers();
  },
  watch: {
    cartList(newValue, oldValue) {
      this.getCheckout();
    },
  },
  computed: {
    cartList() {
      return this.$store.getters.getCarts;
    },
    shimmer() {
      return this.$store.state.module.shimmer
    }
  },
  methods: {
    loadSimilers(){
      let url = this.getUrl("api/v100/similar_products");
			axios.get(url).then((response) => {
				this.disable = false;
				if (response.data.error) {
					toastr.error(response.data.error, this.lang.Error + " !!");
				} else {
          this.similers=response.data.data
          console.log(this.similers,'iiiuux');
					// this.$store.commit("getUserCompare", response.data.product);
					// this.$store.dispatch("compareList", response.data.compare_list);
				}
			});
    },
    getCheckout() {
      this.$Progress.start();
      let url = this.getUrl('cart/list?cart_page=1');
      axios.get(url).then((response) => {
        this.is_shimmer = true;
        this.$store.commit('setShimmer', 0);
        if (response.data.error) {
          this.$Progress.fail();
          toastr.error(response.data.error, this.lang.Error + ' !!');
        } else {
          this.$Progress.finish();
          let checkouts = response.data.checkouts;
          let coupons = response.data.coupons;
          this.parseData(this.cartList, checkouts, coupons);
        }
      })
    },
    deleteCart(id) {
      if (confirm("Are you sure?")) {
        let url = this.getUrl('cart/delete/' + id);
        axios.get(url).then((response) => {
          if (response.data.error) {
            toastr.error(response.data.error, this.lang.Error + ' !!');
          } else {
            this.$store.dispatch('carts', response.data.carts);
          }
        })
      }
    },
    checkout() {
      if (!this.authUser) {
        toastr.error(this.lang.login_first, this.lang.Error + ' !!');
        this.$store.commit('setLoginRedirection', this.$route.name);
        this.$router.push({name: 'login'});
        return false;
      }
      if (this.authUser.user_type != 'customer') {
        return toastr.warning(this.lang.you_are_not_able_topurchase_products, this.lang.Warning + ' !!');
      }
      this.$router.push({name: 'checkout'});
    },
    parseData(carts, checkouts, coupons) {
      this.resetForm();
      this.collapseAttribute = [];
      this.carts = [];

      if (carts) {
        for (let i = 0; i < carts.length; i++) {
          this.payment_form.quantity.push({id: carts[i].id, quantity: carts[i].quantity});
          this.carts.push(carts[i]);
          this.payment_form.sub_total += parseFloat(carts[i].price * carts[i].quantity);
          this.payment_form.discount_offer += (parseFloat(carts[i].discount) * carts[i].quantity);
          if (this.settings.shipping_cost == 'product_base') {
            this.payment_form.shipping_tax += parseFloat(carts[i].shipping_cost);
          }

          this.payment_form.tax += parseFloat(carts[i].tax * carts[i].quantity);
        }
      }

      if (checkouts) {
        this.seller_carts = checkouts;
        this.coupon = checkouts;

        for (let key in this.seller_carts) {
          this.collapseAttribute.push({
            name: checkouts[key].name,
            image: checkouts[key].image,
            status: true,
          });
          if (this.settings.shipping_cost != 'area_base') {
            this.payment_form.shipping_tax += parseFloat(checkouts[key].shipping_cost);
          }
          this.payment_form.tax += parseFloat(checkouts[key].tax);
          if (this.settings.coupon_system == 1) {
            this.payment_form.coupon_discount += parseFloat(checkouts[key].discount);
          }
        }
      }

      if (coupons && this.settings.coupon_system == 1) {
        this.coupon_list = coupons;
        for (let i = 0; i < coupons.length; i++) {
          this.payment_form.coupon_discount += parseFloat(coupons[i].discount);
        }
      }

      if (this.settings.tax_type == 'after_tax' && this.settings.vat_and_tax_type == 'order_base') {
        this.payment_form.total = (parseFloat(this.payment_form.sub_total) + parseFloat(this.payment_form.shipping_tax)) - (parseFloat(this.payment_form.discount_offer) + parseFloat(this.payment_form.coupon_discount));
        this.payment_form.total += this.payment_form.tax;
        if(this.payment_form.total < 0){
          this.payment_form.total = 0;
        }
      } else {
        this.payment_form.total = (parseFloat(this.payment_form.sub_total) + parseFloat(this.payment_form.tax) + parseFloat(this.payment_form.shipping_tax)) - (parseFloat(this.payment_form.discount_offer) + parseFloat(this.payment_form.coupon_discount));
        if(this.payment_form.total < 0){
          this.payment_form.total = 0;
        }
      }

    },
    cartPlus(index) {
      if (this.disable) {
        return false;
      }
      if (this.payment_form.quantity[index].quantity < this.carts[index].current_stock) {
        let formData = {
          id: this.carts[index].id,
          quantity: 1,
        };

        this.disable = true;
        let url = this.getUrl('cart/update');
        axios.post(url, formData).then((response) => {
          this.disable = false;
          if (response.data.error) {
            toastr.error(response.data.error, this.lang.Error + ' !!');
          } else {
            this.$store.dispatch('carts', response.data.carts);
            let coupons = response.data.coupons;
            this.parseData(this.cartList, response.data.checkouts, coupons);
          }
        }).catch((error) => {
          this.disable = false;
        })


      } else {
        toastr.warning(this.lang.Only + ' ' + this.carts[index].current_stock + ' ' + this.lang.items_available_at_this_time, this.lang.Warning + ' !!');
      }
    },
    cartMinus(index) {
      if (this.disable) {
        return false;
      }
      if (this.payment_form.quantity[index].quantity > this.carts[index].min_quantity) {
        let formData = {
          id: this.carts[index].id,
          quantity: -1,
          status: 'minus',
        };

        let url = this.getUrl('cart/update');
        this.disable = true;

        axios.post(url, formData).then((response) => {
          this.disable = false;
          if (response.data.error) {
            toastr.error(response.data.error, this.lang.Error + ' !!');
          } else {
            this.$store.dispatch('carts', response.data.carts);
            let coupons = response.data.coupons;
            let checkouts = response.data.checkouts;
            this.parseData(this.cartList, checkouts, coupons);
          }
        })


      } else {
        toastr.warning(this.lang.please_order_minimum_of + ' ' + this.carts[index].min_quantity + ' ' + this.lang.Quantity, this.lang.Warning + ' !!');
      }
    }
  }
}
</script>
